#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "jupiter_db.h"

int print_fields(DBHANDLE db, void *user_data, int num_fields, tbl_field *fields) {

	int i = 0;
	if (num_fields > 0) {
		for (i=0; i<num_fields; i++) {
			printf ("field %d pos is %d\n", i, fields[i].pos);
			printf ("field %d name is %s\n", i, fields[i].name);
			printf ("field %d type is %d\n", i, fields[i].type);
		}	
	}
	return 1;
}

int print_records(DBHANDLE db, void *user_data, const char *records) {
	
	printf("Records are: \n%s", records);	

	return 1;
}

void run_db_test_1(){
	char data[DATLEN_MAX];
	char key[IDXLEN_MAX];
	DBHANDLE DB;
	char i;
	int init_len;
	tbl_field fields[5];
	void *ud;

	DB = db_open("test", (O_CREAT | O_TRUNC | O_RDWR), S_IRWXU);
	
	fields[0].type = STRING;
	fields[0].name = (char *)malloc(100 * sizeof(char));
	strcpy(fields[0].name, "Key_Value");
	fields[0].pos = 1;
	fields[1].type = STRING;
	fields[1].name = (char *)malloc(100 * sizeof(char));
	strcpy(fields[1].name, "Name");
	fields[1].pos = 2;
	fields[2].type = INT;
	fields[2].name = (char *)malloc(100 * sizeof(char));
	strcpy(fields[2].name, "Birthdate");
	fields[2].pos = 3;
	fields[3].type = INT;
	fields[3].name = (char *)malloc(100 * sizeof(char));
	strcpy(fields[3].name, "Zipcode");
	fields[3].pos = 4;
	fields[4].type = STRING;
	fields[4].name = (char *)malloc(100 * sizeof(char));
	strcpy(fields[4].name, "phone");
	fields[4].pos = 5;
	
	db_tbl_create(DB, "EMPL", fields, 5);
	strcpy(key, "key");
	init_len = strlen(key);
	
	for (i='A'; i<'z'; i++){
		key[init_len] = i;
		key[init_len+1] = '\0';
		strcpy(data, "DINESH,0101,49985,111-1132");
		db_store(DB, "EMPL", key, data, DB_INSERT);
	}
	
	for (i='A'; i<'L'; i++){
		key[init_len] = i;
		key[init_len+1] = '\0';
		fprintf(stderr, "deleting %s\n", key);
		db_delete(DB, "EMPL", key);
	}

	db_getfieldinfo(DB, "EMPL", ud, print_fields); 
	db_retrieve(DB, "EMPL", ud, print_records);	
	
	db_close(DB);
    return;
}

void run_db_test_2(){
	DBHANDLE DB;
	char key[IDXLEN_MAX];
	char *records;
	char *fetched_data;
	void *ud;
	char i;
	int init_len;
    
    DB = db_open("test", O_RDWR, S_IRWXU);

	fetched_data = (char *)malloc(DATLEN_MAX * sizeof(char));	
	records = (char *)malloc(1000 * DATLEN_MAX * sizeof(char));	

	strcpy(key, "key");
	init_len = strlen(key);

	for (i='O'; i<'Z'; i++){
		key[init_len] = i;
		key[init_len+1] = '\0';
		fetched_data = db_fetch(DB, "EMPL", key);
		fprintf(stderr, "fetched record is %s,%s\n", key, fetched_data);
	}
	
	for (i='O'; i<'Z'; i++){
		key[init_len] = i;
		key[init_len+1] = '\0';
		fprintf(stderr, "deleting %s\n", key);
		db_delete(DB, "EMPL", key);
	}

	db_getfieldinfo(DB, "EMPL", ud, print_fields); 
	db_retrieve(DB, "EMPL", ud, print_records);	
	
	db_close(DB);
    return;
}

int main (){

    run_db_test_1();
	run_db_test_2();
    return 1;
}
